<template>
  <div>
    <div class="fields">
      <st-title text="Estado de última cita"/>
      <v-row>
        <v-col>
          <v-row>
            <v-col md="3"><v-label>Alumno:</v-label></v-col>
            <v-col md="6"><v-label>{{ currentAppointment.studentName }}</v-label></v-col>
          </v-row>
          <v-row>
            <v-col md="3"><v-label>Tutor:</v-label></v-col>
            <v-col md="6"><v-label>{{ currentAppointment.tutorName }}</v-label></v-col>
          </v-row>
          <v-row>
            <v-col md="3"><v-label>Fecha de atención:</v-label></v-col>
            <v-col md="6"><v-label>{{ currentAppointment.attentionDate }}</v-label></v-col>
          </v-row>
          <v-row>
            <v-col md="3"><v-label>Estado de la cita:</v-label></v-col>
            <v-col md="6"><v-label>{{ currentAppointment.appointmentState }}</v-label></v-col>
          </v-row>
          <div class="space2" />
            <v-sheet class="alert" :color="color">
              <v-row>
                <v-col md="12" align-self="center">
                  <div class="space" />
                  <v-row justify="center">
                    <v-col class="centro">
                      <v-label>{{ alertMessage }}</v-label>
                    </v-col>
                  </v-row>
                  <div class="space" />
                </v-col>
              </v-row>
            </v-sheet>
            <div class="space2" />
        </v-col>
      </v-row>
    </div>

    <div class="content-footer">
      <st-secondary-btn nombre="Cancelar" @click="$emit('cancel')"/>
      <st-primary-btn nombre="Siguiente" @click="$emit('next')" :disable="!alertOk"/>
    </div>
  </div>
</template>

<script>
export default {
  data() { return {
    alertMessage: "",
    alertOk: false,
    currentAppointment: {
      studentName: '-',
      tutorName: '-',
      attentionDate: '-',
      appointmentState: '-'
    },
    color: "#E7F5EB"
  }},
  name: "TutorshipSessionModalStepTwo",
  props: {appointment: Object},
  mounted() {
    // confirmamos si la propiedad pasada ha sido alterada por el paso anterior
    let now = this.appointment
    if (now && now !== {} && now.student && now.student !== {}) {
      const lastSession = now.student.ultimaSesion;
      this.currentAppointment.studentName = now.student.nombre;
      // no posee ninguna sesion durante su participacion en la tutoria
      if (!lastSession || !lastSession.estado || lastSession === {}) return this.noAppointment();

      // posee al menos una sesion
      this.currentAppointment.tutorName = lastSession.tutorAsignado ? lastSession.tutorAsignado.nombre : '-';
      this.currentAppointment.attentionDate = now.student.fechaFormato;
      this.currentAppointment.appointmentState = lastSession.estado;

      if (lastSession.estado === 'Atendido') return this.appointmentAttended(lastSession);
      else if (lastSession.estado === 'Cancelado') return this.appointmentCancelled(lastSession);
      else if (lastSession.estado === 'Pendiente') return this.appointmentPending(lastSession);
      else if (lastSession.estado === 'Solicitado') return this.appointmentRequested(lastSession);
    }
  },
  methods: {
    noAppointment() {
      this.alertMessage = "No se tienen citas pendientes. Puede registrar una.";
      this.alertOk = true;
      this.color = "#E7F5EB";
    },
    appointmentAttended(appointment) {
      this.alertMessage = "Ya se ha atendido esta cita. Puede registrar otra.";
      this.alertOk = true;
      this.color = "#E7F5EB";
    },
    appointmentCancelled(appointment) {
      this.alertMessage = "Esta cita se encuentra cancelada. Puede registrar otra.";
      this.alertOk = true;
      this.color = "#E7F5EB";
    },
    appointmentPending(appointment) {
      this.alertMessage = "Esta cita se encuentra en proceso de atención. No puede registrar otra hasta que sea atendida.";
      this.alertOk = false;
      this.color = "#FEE8E8";
    },
    appointmentRequested(appointment) {
      this.alertMessage = "Esta cita se encuentra en proceso de atención. No puede registrar otra hasta que sea atendida.";
      this.alertOk = false;
      this.color = "#FEE8E8";
    },
  }
}
</script>

<style scoped>
.space {
  height: 10px;
}
.space2 {
  height: 130px;
}
.alert {
  height: 200;
  margin: 200;
}
.centro {
  text-align: center;
}
</style>
